var photos, imgNum, imgCurr;
var transDiv, cardDiv, imgFront, imgBack, imgCover, thmHold, thmImgs;

function hasClass(elem, cls) { return (new RegExp("(\\s|^)" + cls + "(\\s|$)")).test(elem.className); }
function addClass(elem, cls) { if (!this.hasClass(elem, cls)) elem.className += " " + cls; }
function removeClass(elem, cls) { if (hasClass(elem, cls)) elem.className = elem.className.replace(new RegExp("(\\s|^)" + cls + "(\\s|$)"), " "); }

function addPrefixedEvent(elem, type, callback) {
	var prefixes = ["webkit", "moz", "MS", "o", ""];
	for (var p = 0; p < prefixes.length; p++)
		elem.addEventListener(prefixes[p] + ((prefixes[p]) ? type : type.toLowerCase()), callback, false);
}

// inicializljuk az oldalt
function initPage() {
	var photosDiv = document.getElementById("photos");						// itt tallhat az sszes fot
	photos = photosDiv.getElementsByTagName("img");							// ebbe gyjtttk ssze a kpeket
	imgNum = photos.length;													// ennyi kpbl ll a galria
	imgCurr = 0;															// az aktulis kp szma
 
	transDiv = document.getElementById("transition");						// ezen bell trtnik az tmenet
	cardDiv  = document.getElementById("tr-card");							// tbbnyire ezt animljuk majd
	imgFront = document.getElementById("tr-front");							// ezekben kell cserlgetni majd a kpeket
	imgBack  = document.getElementById("tr-back");
	imgCover = document.getElementById("cover");							// ezzel takarjuk le az egszet az animci vgn
	imgCover.innerHTML = '<img src="' + photos[0].src + '">';				// kezdetnek belltjuk az els kpet

	thmHold = document.getElementById("th-hold");							// ez lesz a lthat indexkp
	thmImgs = document.getElementById("th-imgs");							// ebben lesznek az indexkpek
	var thImgs = "";														// ide gyjtjk az indexkpeket
	var thDots = document.getElementById("th-dots");						// ide jnnek az indexkpek pttyei
	thDots.style.width = (imgNum * 26) + "px";								// gy tudjuk kzpre igaztani
	for (var i = 0; i < imgNum; i++) {
		var imgSpan = document.createElement("span");						// ltrohozunk egy <span> elemet
		imgSpan.id  = "imgThumb" + i;										// adunk neki egy azonostt
		imgSpan.onclick = showImage;										// ha rkattintanak, kpetvltunk
		imgSpan.onmouseover = moveThumbs;									// ha fl r az egr, akkor vltjuk az indexkpet
		thDots.appendChild(imgSpan);										// hozzadjuk a "indexkpekhez"
		if (i == 0) addClass(imgSpan, "active");							// az els lesz az aktv
		
		thImgs += '<img src="' + photos[i].src + '">';						// szpen egyms mg tesszk a kpeket
	}
	thmImgs.innerHTML = thImgs;												// az indexkpek elhelyezse
	
	addPrefixedEvent(cardDiv, "AnimationEnd", animationEnd);				// befejezdtt az animci
	addPrefixedEvent(imgFront, "AnimationEnd", animationEnd);				// elfordulhat, hogy a kpeket kln animljuk
}

function showImage(evt) {
	if (hasClass(transDiv, "show")) return;									// ha megy az animci, akkor hiba kattintott

	var imgNext = parseInt(evt.target.id.replace("imgThumb", ""), 10);		// ezt a kpet vlasztottk
	if (imgCurr == imgNext) return;											// ha ez az aktulis, akkor nincs mit cserlni
	
	imgFront.innerHTML = '<img src="' + photos[imgCurr].src + '">';			// betltjk az aktulis kpet elre
	imgBack.innerHTML  = '<img src="' + photos[imgNext].src + '">';			// a kvetkez kpet pedig htra
	addClass(transDiv, "show");												// kezddhet az animci
	addClass(imgCover, "hide");												// elrejtjk a bortkpet
	
	removeClass(document.getElementById("imgThumb" + imgCurr), "active");	// mr nem ez az aktulis
	imgCurr = imgNext;														// a kvetkez kp lesz az aktulis
	addClass(document.getElementById("imgThumb" + imgCurr), "active");		// mostantl ez az aktulis

	imgCover.innerHTML = '<img src="' + photos[imgCurr].src + '">';			// a bortkp tartalmt is kicserljk
}

function animationEnd(evt) {
	removeClass(imgCover, "hide");											// megjelentjk a bortkpet
	removeClass(transDiv, "show");											// mr vge az animcinak
}

function moveThumbs(evt) {
	var imgOver = parseInt(evt.target.id.replace("imgThumb", ""), 10);		// e fltt van az egr
	thmHold.style.left = (evt.target.offsetLeft - 55) + "px";
	thmImgs.style.left = (-imgOver * 120) + "px";
}

window.onload = initPage;
