var photos, imgNum, imgCurr, imgSlc;
var transDiv, cardDiv, imgFront, imgBack, imgCover, divStat;			

function hasClass(elem, cls) { return (new RegExp("(\\s|^)" + cls + "(\\s|$)")).test(elem.className); }
function addClass(elem, cls) { if (!this.hasClass(elem, cls)) elem.className += " " + cls; }
function removeClass(elem, cls) { if (hasClass(elem, cls)) elem.className = elem.className.replace(new RegExp("(\\s|^)" + cls + "(\\s|$)"), " "); }

function addPrefixedEvent(elem, type, callback) {
	var prefixes = ["webkit", "moz", "MS", "o", ""];
	for (var p = 0; p < prefixes.length; p++)
		elem.addEventListener(prefixes[p] + ((prefixes[p]) ? type : type.toLowerCase()), callback, false);
}

// inicializljuk az oldalt
function initPage() {
	var photosDiv = document.getElementById("photos");						// itt tallhat az sszes fot
	photos = photosDiv.getElementsByTagName("img");							// ebbe gyjtttk ssze a kpeket
	imgNum = photos.length;													// ennyi kpbl ll a galria
	imgCurr = 0;															// az aktulis kp szma
 
	transDiv = document.getElementById("transition");						// ezen bell trtnik az tmenet
	imgFront = document.getElementsByClassName("tr-front");					// ezekben kell cserlgetni majd a kpeket
	imgBack  = document.getElementsByClassName("tr-back");
	imgSlc   = imgFront.length;												// ennyi darabra vannak vgva a kpek
	imgCover = document.getElementById("cover");							// ezzel takarjuk le az egszet az animci vgn
	imgCover.innerHTML = '<img src="' + photos[0].src + '">';				// kezdetnek belltjuk az els kpet
	divStat  = document.getElementById("status");							// hol tartunk a gallriban?
	divStat.style.width = "0%";												// egyelre a legelejn

	var buttons = document.getElementById("buttons");						// ebben vannak stlusvlt gombok
	var button  = document.getElementById("button");						// ez indtja az animcit
	
	var spans = buttons.getElementsByTagName("span");						// a stlusvlt gombok
	for (var s = 0; s < spans.length; s++) {
		spans[s].onclick = function() { setStyle(this); };					// cserljk az ttns stlust
		spans[s].title = spans[s].id;										// hogy ltni lehessen, melyik effektusrl van sz
	}
	setStyle(spans[0]);														// alaprtelmezettnek belltjuk az els stlust
	
	button.onclick = function() { showNextImage(); return false; };			// kattintskor jhet a kvetkez kp

	addPrefixedEvent(imgBack[imgSlc - 1], "AnimationEnd", animationEnd);	// befejezdtt az animci - mindig az utols fejez
}

function setStyle(obj) {
	if (hasClass(transDiv, "show")) return;									// ha megy az animci, akkor hiba kattintott

	var spans = obj.parentNode.getElementsByTagName("span");				// itt van az sszes stlusvlt
	for (var s = 0; s < spans.length; s++)
		removeClass(spans[s], "active");									// mindrl leszedjk az "active" osztlyt
	addClass(obj, "active");												// a tnyleg aktulison belltjuk
	
	transDiv.className = obj.id;											// belltjuk az j stlust
}

function showNextImage() {
	if (hasClass(transDiv, "show")) return;									// ha megy az animci, akkor hiba kattintott
	
	var imgNext = (imgCurr < imgNum - 1) ? imgCurr + 1 : 0;					// ez a kvetkez kp
	
	for (var i = 0; i < imgSlc; i++) {
		imgFront[i].innerHTML = '<img src="' + photos[imgCurr].src + '">';	// betltjk az aktulis kpet elre
		imgBack[i].innerHTML  = '<img src="' + photos[imgNext].src + '">';	// a kvetkez kpet pedig htra
	}
	addClass(transDiv, "show");												// kezddhet az animci
	addClass(imgCover, "hide");												// elrejtjk a bortkpet
	imgCurr = imgNext;														// a kvetkez kp lesz az aktulis
	imgCover.innerHTML = '<img src="' + photos[imgCurr].src + '">';			// a bortkp tartalmt is kicserljk
	divStat.style.width = (imgCurr / (imgNum - 1) * 100) + "%";				// frisstjk a ststuscskot
}

function animationEnd(evt) {
	removeClass(imgCover, "hide");											// megjelentjk a bortkpet
	removeClass(transDiv, "show");											// mr vge az animcinak
}

window.onload = initPage;
